#include<iostream>
#include<vector>
#include<queue>
#include<tuple>
using namespace std;

vector<vector<bool> > grid;
vector<vector<int> > visited;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    for(int i=0; i<n; i++)
    {
        string row;
        cin >> row;

        vector<bool> rowGrid;
        vector<int> rowVisited;
        for(int j=0; j<m; j++)
        {
            rowGrid.push_back(row[j]=='.'?true:false);
            rowVisited.push_back(0);
        }
        grid.push_back(rowGrid);
        visited.push_back(rowVisited);
    }

    queue<tuple<int, int, int> > q;
    q.push({0, 0, 1});
    while(!q.empty())
    {
        int r, c, t;
        tie(r, c, t) = q.front();
        q.pop();

        if(!grid[r][c])
        {
            continue;
        }

        if(visited[r][c]>=t)
        {
            continue;
        }
        visited[r][c]=t;

        if(r==n-1 && c==m-1)
        {
            break;
        }

        if(t>n && t>m)
        {
            continue;
        }

        q.push({r, c, t+1});
        if(r-t>=0)
        {
            q.push({r-t, c, t+1});
        }
        if(r+t<n)
        {
            q.push({r+t, c, t+1});
        }
        if(c-t>=0)
        {
            q.push({r, c-t, t+1});
        }
        if(c+t<m)
        {
            q.push({r, c+t, t+1});
        }
    }

    cout << visited[n-1][m-1]-1 << "\n";

    return 0;
}
