#include<iostream>
#include<vector>
#include<queue>
#include<tuple>
using namespace std;

const int MAXN=5000, MAXM=5000;

vector<vector<bool> > grid;
vector<vector<int> > l, r, u, d, ans;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    grid.resize(n);
    l.resize(n);
    r.resize(n);
    u.resize(n);
    d.resize(n);
    ans.resize(n);

    for(int i=0; i<n; i++)
    {
        string row;
        cin >> row;

        for(int j=0; j<m; j++)
        {
            grid[i].push_back(row[j]=='.'?true:false);

            l[i].push_back(-1);
            r[i].push_back(-1);
            u[i].push_back(-1);
            d[i].push_back(-1);
            ans[i].push_back(0);
        }
    }

    queue<tuple<int, int, int, char> > q;
    q.push({0, 0, 1, 'r'});
    q.push({0, 0, 1, 'd'});
    while(!q.empty())
    {
        int i, j, t, direction;
        tie(i, j, t, direction) = q.front();
        q.pop();

        if(direction=='r' && r[i][j]==-1)
        {
            r[i][j]=t;

            if(j<m-1)
                q.push({i, j+1, t+1, 'r'});
        }
        if(direction=='u' && u[i][j]==-1)
        {
            u[i][j]=t;

            if(i>0)
                q.push({i-1, j, t+1, 'u'});
        }
        if(direction=='d' && d[i][j]==-1)
        {
            d[i][j]=t;

            if(i<n-1)
                q.push({i+1, j, t+1, 'd'});
        }
        if(direction=='l' && l[i][j]==-1)
        {
            l[i][j]=t;

            if(j>0)
                q.push({i, j-1, t+1, 'l'});
        }

        if(!grid[i][j] || (ans[i][j]!=0 && ans[i][j]<=t))
        {
            continue;
        }
        ans[i][j]=t;

        if((i==n-1 && j==m-1) || (t>n && t>m))
        {
            break;
        }

        if(i-t>=0)
        {
            q.push({i-t, j, t+1, 'u'});
        }
        if(i+t<n)
        {
            q.push({i+t, j, t+1, 'd'});
        }
        if(j-t>=0)
        {
            q.push({i, j-t, t+1, 'l'});
        }
        if(j+t<m)
        {
            q.push({i, j+t, t+1, 'r'});
        }
    }

    cout << ans[n-1][m-1]-1 << "\n";

    return 0;
}
