#include<iostream>
#include<queue>
#include<tuple>
using namespace std;

const int MAXN = 5000;

vector<int> graph[MAXN];
bool v[MAXN];
vector<int> edges;
int nodes=0;
int v2[MAXN][MAXN], v3[MAXN][MAXN], v5[MAXN][MAXN];

bool BFS5(int src)
{
    queue<tuple<int, int, int> > q;
    q.push({src, -1, 0});

    while(!q.empty())
    {
        int x, pr, t;
        tie(x, pr, t)=q.front();
        q.pop();

        if(x!=src && v5[src][x]==2 && t==3)
        {
            return true;
        }

        if(t==3)
        {
            continue;
        }

        if(v5[src][x]!=0)
        {
            continue;
        }
        v5[src][x]=t;

        for(int y:graph[x])
        {
            if(y==pr)
                continue;

            q.push({y, x, t+1});
        }
    }

    return false;
}

bool BFS4(int src)
{
    queue<pair<int, int> > q;
    q.push({src, 0});

    while(!q.empty())
    {
        int x, t;
        tie(x, t)=q.front();
        q.pop();

        if(x!=src && v2[src][x]==2 && t==2)
        {
            return true;
        }

        if(t==2)
        {
            v2[src][x]=2;
            continue;
        }

        if(v2[src][x]!=0)
        {
            continue;
        }
        v2[src][x]=t;

        for(int y:graph[x])
        {
            q.push({y, t+1});
        }
    }

    return false;
}

bool BFS3(int src)
{
    queue<tuple<int, int, int> > q;
    q.push({src, -1, 0});

    while(!q.empty())
    {
        int x, pr, t;
        tie(x, pr, t)=q.front();
        q.pop();

        if(x!=src && v3[src][x]==1 && t==2)
        {
            return true;
        }

        if(t==2)
        {
            continue;
        }

        if(v3[src][x]!=0)
        {
            continue;
        }
        v3[src][x]=t;

        for(int y:graph[x])
        {
            if(y==pr)
                continue;

            q.push({y, x, t+1});
        }
    }

    return false;
}


void BFS(int idx)
{
    queue<int> q;
    q.push(idx);

    while(!q.empty())
    {
        idx=q.front();
        q.pop();

        if(v[idx])
        {
            continue;
        }
        v[idx]=true;

        edges.push_back(idx);
        nodes+=graph[idx].size();

        for(int x:graph[idx])
        {
            q.push(x);
        }
    }
}

int main()
{
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);

    int n;
    cin >> n;

    for(int i=0; i<n-1; i++)
    {
        v[i]=false;
        string row;
        cin >> row;

        for(int j=0; j<n-1-i; j++)
        {
            v2[i][j+i+1]=0;
            v2[j+i+1][j+i+1]=0;
            v3[i][j+i+1]=0;
            v3[j+i+1][j+i+1]=0;
            v5[i][j+i+1]=0;
            v5[j+i+1][j+i+1]=0;

            if(row[j]=='1')
            {
                graph[i].push_back(j+i+1);
                graph[j+i+1].push_back(i);
            }
        }
    }
    v[n-1]=false;

    /*for(int i=0; i<n; i++)
    {
        cout << i << " -> ";
        for(int x:graph[i])
        {
            cout << x << " ";
        }
        cout << "\n";
    }*/

    int ans=-1;
    for(int i=0; i<n; i++)
    {
        if(!v[i])
        {
            edges.clear();
            nodes=0;
            BFS(i);

            nodes/=2;

            if(edges.size()>=4)
            {
                if(BFS4(i))
                {
                    ans=2;
                    break;
                }

                if((BFS3(i) || BFS5(i)) && (ans==-1 || ans>3))
                {
                    ans=3;
                    continue;
                }

                int cnt=0;
                for(int x:edges)
                {
                    if(graph[x].size()>=2)
                    {
                        cnt++;
                    }
                }

                if(cnt>=2 && (ans==-1 || ans>4))
                {
                    ans=4;
                }
            }
        }
    }

    cout << ans << "\n";

    return 0;
}
