#include "crption.h"
#include<stack>
#include<algorithm>
using namespace std;

const int MAXN=1e5;

vector<int> graph[MAXN];
stack<int> path;
bool v[MAXN], corrupt[MAXN];
int cnt[MAXN];

void DFS(int idx)
{
    if(v[idx])
    {
        return;
    }
    v[idx]=true;

    for(int x:graph[idx])
    {
        DFS(x);
    }

    path.push(idx);
}

vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    vector<int> ans;

    for(int i=0; i<n; i++)
    {
        v[i]=false;
        cnt[i]=0;
        corrupt[i]=false;
    }

    int m=from.size(), k=0;
    for(int i=0; i<m; i++)
    {
        if(check(from[i], to[i]))
        {
            corrupt[i]=true;
            k++;
        }

        if(k==20)
        {
            break;
        }
    }

    for(int i=0; i<m; i++)
    {
        if(corrupt[i])
        {
            graph[to[i]].push_back(from[i]);
            cnt[from[i]]++;
        }
        else
        {
            graph[from[i]].push_back(to[i]);
            cnt[to[i]]++;
        }
    }

    for(int i=0; i<n; i++)
    {
        if(cnt[i]==0)
        {
            DFS(i);
            break;
        }
    }

    while(!path.empty())
    {
        ans.push_back(path.top());
        path.pop();
    }

    return ans;
}
