#include "crption.h"
#include<stack>
#include<algorithm>
using namespace std;

const int MAXN=1e5;

vector<int> mygraph[MAXN];
stack<int> mypath;
bool myv[MAXN], mycorrupt[MAXN];
int mycnt[MAXN];

void DFS(int idx)
{
    if(myv[idx])
    {
        return;
    }
    myv[idx]=true;

    for(int x:mygraph[idx])
    {
        DFS(x);
    }

    mypath.push(idx);
}

vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    vector<int> ans;

    for(int i=0; i<n; i++)
    {
        myv[i]=false;
        mycnt[i]=0;
        mycorrupt[i]=false;
    }

    int m=from.size(), k=0;
    for(int i=0; i<m; i++)
    {
        if(check(from[i], to[i]))
        {
            mycorrupt[i]=true;
            k++;
        }

        if(k==20)
        {
            break;
        }
    }

    for(int i=0; i<m; i++)
    {
        if(mycorrupt[i])
        {
            mygraph[to[i]].push_back(from[i]);
            mycnt[from[i]]++;
        }
        else
        {
            mygraph[from[i]].push_back(to[i]);
            mycnt[to[i]]++;
        }
    }

    for(int i=0; i<n; i++)
    {
        if(mycnt[i]==0)
        {
            DFS(i);
            break;
        }
    }

    while(!mypath.empty())
    {
        ans.push_back(mypath.top());
        mypath.pop();
    }

    return ans;
}
