#include "crption.h"
#include<stack>
#include<algorithm>
using namespace std;

const int MAXN=1e5;

vector<int> mygraph[MAXN];
stack<int> mypath;
bool myv[MAXN], mycorrupt[MAXN];
int mycnt[MAXN], mygraphidx[MAXN];

void DFS(int idx)
{
    stack<int> dfsst;
    dfsst.push(idx);

    while(!dfsst.empty())
    {
        int x = dfsst.top();

        if(myv[x])
        {
            dfsst.pop();
            continue;
        }

        if(mygraphidx[x]==mygraph[x].size())
        {
            mypath.push(x);
            dfsst.pop();
            myv[x]=true;
        }
        else
        {
            dfsst.push(mygraph[x][mygraphidx[x]]);
            mygraphidx[x]++;
        }
    }
}

vector<int> solve(const int &n, const vector<int> &from, const vector<int> &to)
{
    vector<int> ans;

    for(int i=0; i<n; i++)
    {
        myv[i]=false;
        mycnt[i]=0;
        mycorrupt[i]=false;
        mygraphidx[i]=0;
    }

    int m=from.size(), k=0;
    for(int i=0; i<m; i++)
    {
        if(check(from[i], to[i]))
        {
            mycorrupt[i]=true;
            k++;
        }

        if(k==20)
        {
            break;
        }
    }

    for(int i=0; i<m; i++)
    {
        if(mycorrupt[i])
        {
            mygraph[to[i]].push_back(from[i]);
            mycnt[from[i]]++;
        }
        else
        {
            mygraph[from[i]].push_back(to[i]);
            mycnt[to[i]]++;
        }
    }

    for(int i=0; i<n; i++)
    {
        if(mycnt[i]==0)
        {
            DFS(i);
            break;
        }
    }

    while(!mypath.empty())
    {
        ans.push_back(mypath.top());
        mypath.pop();
    }

    return ans;
}
/*
4 3 0
0 2 1 3
0 2
2 1
1 3
*/
