#include <iostream>
#include <vector>
#include <queue>

using namespace std;

const int MAXN = 1000001;

typedef long long ll;

struct st{
    int x;
    int y;
    int t;
};

int n,m;
vector<bool> a[MAXN];
string s[MAXN];
st begSt;

int bfs()
{
    queue<st> q;
    q.push(begSt);

    while(!q.empty())
    {
        st temp=q.front();
        q.pop();

        a[temp.x][temp.y]=true;

        if(temp.x+temp.t<n&&(!a[temp.x+temp.t][temp.y]))
        {
            if(temp.x+temp.t==n-1&&temp.y==m-1) return temp.t;
            q.push({temp.x+temp.t,temp.y,temp.t+1});
        }
        if(temp.y+temp.t<m&&(!a[temp.x][temp.y+temp.t]))
        {
            if(temp.x==n-1&&temp.y+temp.t==m-1) return temp.t;
            q.push({temp.x,temp.y+temp.t,temp.t+1});
        }
        if(temp.x>=temp.t&&(!a[temp.x-temp.t][temp.y]))
            q.push({temp.x-temp.t,temp.y,temp.t+1});
        if(temp.y>=temp.t&&(!a[temp.x][temp.y-temp.t]))
            q.push({temp.x,temp.y-temp.t,temp.t});
        if(temp.t<n)
            q.push({temp.x,temp.y,temp.t+1});
    }

    return -1;
}

void init()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    scanf("%d%d",&n,&m);

    for(int i=0;i<n;i++)
        cin>>s[i];

    if(n<m)
    {
        for(int i=0;i<m;i++)
        {
            for(int j=n-1;j>=0;j--)
            {
                if(s[j][i]=='.')
                    a[i].push_back(false);
                else
                    a[i].push_back(true);
            }
        }
        swap(n,m);

        begSt={0,m,1};
    }
    else
    {
        for(int i=0;i<n;i++)
        {
            for(int j=0;j<m;j++)
            {
                if(s[i][j]=='.')
                    a[i].push_back(false);
                else
                    a[i].push_back(true);
            }
        }
        begSt={0,0,1};
    }
}

void prnt()
{
    for(int i=0;i<n;i++)
    {
        for(int j=0;j<m;j++)
        {
            cout<<a[i][j]<<" ";
        }
        cout<<endl;
    }
}

int main()
{
    init();

    cout<<bfs()<<" ";
}
/*
2 2
.#
#.

3 2
#.
##
..

2 3
.##
###

1 6
..#...

1 7
.#.#...

....#.....
..#.......
..##......

5 5
.....
.....
.....
.....
.....
*/
