#include<bits/stdc++.h>
#define pb push_back
using namespace std;

template<class T> using matrix = vector<vector<T>>;

int N;
matrix<int> G, dist;

int main(){
    cin >> N;
    G = matrix<int>(N + 1);
    dist = matrix<int>(N + 1, vector<int>(N + 1, 1e9));
    for(int u = 1; u <= N; u ++){
        for(int v = 1; v < u; v ++){
            int x; cin >> x;
            if(x){
                G[u].pb(v);
                G[v].pb(u);
            }
        }
    }
    for(int s = 1; s <= N; s ++){
        dist[s][s] = 0;
        queue<int> q;
        q.push(s);
        vector<int> used(N + 1);
        while(!q.empty()){
            int u = q.front(); q.pop();
            if(used[u]) continue;
            used[u] = true;
            for(auto v : G[u]){
                if(!used[v]){
                    dist[s][v] = min(dist[s][v], dist[s][u] + 1);
                    q.push(v);
                }
            }
        }
    }
    int ans = 1e9;
    for(int u1 = 1; u1 <= N; u1 ++) for(int u2 = 1; u2 <= N; u2 ++){
        if(u1 == u2) continue;
        for(auto v1 : G[u1]) for(auto v2 : G[u2]){
            if(v1 == v2 || v1 == u2 || v2 == u1) continue;
            ans = min(dist[u1][u2] + dist[v1][v2], ans);
        }
    }
    cout << (ans == 1e9 ? -1 : ans) << endl;
}
