#include<bits/stdc++.h>
#include "crption.h"
using namespace std;
#define pb push_back
#define all(A) A.begin(), A.end()
template<class T> using matrix = vector<vector<T>>;
matrix<int> G;
int M;
vector<int> ord, used;
void dfs(int u){
    used[u] = true;
    for(auto v : G[u]) if(!used[v]){
        dfs(v);
    }
    ord.pb(u);
}

struct unionfind{
    vector<int> sz, par;
    unionfind() {}
    unionfind(int N){
        sz = par = vector<int>(N + 1);
        for(int i = 1; i <= N; i ++){
            sz[i] = 1;
            par[i] = i;
        }
    }
    int get_root(int u){
        return u == par[u] ? u : par[u] = get_root(par[u]);
    }
    void join(int u, int v){
        u = get_root(u);
        v = get_root(v);
        if(u == v) return;
        if(sz[u] > sz[v]) swap(u, v);
        sz[v] += sz[u];
        par[u] = v;
    }
};

mt19937 RAND(time(NULL));

vector <int> solve (const int &N, const vector <int> &from, const vector<int> &to){
    int M = from.size();
    unionfind dsu(N);
    G = matrix<int>(N + 1);
    used = vector<int>(N + 1);
    for(int i = 0; i < M; i ++){
        int u = from[i], v = to[i];
        if(dsu.get_root(u) == dsu.get_root(v)){
            continue;
        }
        else{
            dsu.join(u, v);
            if(check(u, v)) G[v].pb(u);
            else G[u].pb(v);
        }
    }
    for(int i = 0; i < N; i ++){
        if(!used[i]) dfs(i);
    }
    reverse(all(ord));
    return ord;
}
