#include<bits/stdc++.h>
#include "crption.h"
#define pb push_back
#define all(A) A.begin(), A.end()
using namespace std;
template<class T> using matrix = vector<vector<T>>;
matrix<int> G;
int M;
vector<int> ord, used;
void dfs(int u){
    used[u] = true;
    for(auto v : G[u]) if(!used[v]){
        dfs(v);
    }
    ord.pb(u);
}

struct unionfind{
    vector<int> sz, par;
    unionfind() {}
    unionfind(int N){
        sz = par = vector<int>(N + 1);
        for(int i = 0; i < N; i ++){
            sz[i] = 1;
            par[i] = i;
        }
    }
    int get_root(int u){
        return u == par[u] ? u : par[u] = get_root(par[u]);
    }
    void join(int u, int v){
        u = get_root(u);
        v = get_root(v);
        if(u == v) return;
        if(sz[u] > sz[v]) swap(u, v);
        sz[v] += sz[u];
        par[u] = v;
    }
};


vector <int> solve (const int &N, const vector <int> &from, const vector<int> &to){
    G = matrix<int>(N);
    used = vector<int>(N);
    int M = from.size();
    unionfind dsu(N);
    set<int> usedd;
    for(int i = 0; i < M; i ++){
        if(dsu.get_root(from[i]) == dsu.get_root(to[i])) continue;
        dsu.join(from[i], to[i]);
        if(check(from[i], to[i])) G[to[i]].pb(from[i]);
        else G[from[i]].pb(to[i]);
        usedd.insert(i);
    }
    for(int i = 0; i < M; i ++){
        if(usedd.count(i)) continue;
        G[from[i]].pb(to[i]);

    }
    for(int i = 0; i < N; i ++){
        if(!used[i]){
            dfs(i);
        }
    }
    reverse(all(ord));
    return ord;
}
