#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#define endl '\n'
using namespace std;

const int MAXN = 5000;

int cnt = 0;
bool used[MAXN + 5];
vector<int> G[MAXN + 5];
int common[MAXN + 5][MAXN + 5];

void BFS(int u)
{
    queue<int> q;
    q.push(u);
    used[u] = true;
    cnt = 1;
    while (q.size())
    {
        u = q.front();
        q.pop();
        for (auto v : G[u])
        {
            if (!used[v])
            {
                q.push(v);
                used[v] = true;
                cnt++;
            }
        }
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    ///cin >> n;
    n = 5000;

    for (int i = 1; i < n; ++ i)
    {
        for (int j = i + 1; j <= n; ++ j)
        {
            char c;
            ///cin >> c;
            c = '1';
            if (c == '1')
            {
                G[i].push_back(j);
                G[j].push_back(i);
            }
        }
    }

    bool flag = false;
    for (int i = 1; i <= n; ++ i)
    {
        if (!used[i])
        {
            cnt = 0;
            BFS(i);
            if (cnt > 3)
            {
                flag = true;
                break;
            }
        }
    }

    if (!flag)
    {
        cout << -1 << endl;
        return 0;
    }

    for (int u = 1; u <= n; ++ u)
    {
        int sz = G[u].size();
        for (int i = 0; i < sz; ++ i)
        {
            for (int j = i + 1; j < sz; ++ j)
            {
                if (common[G[u][i]][G[u][j]] == 0) common[G[u][i]][G[u][j]] = u;
                else
                {
                    cout << 2 << endl;
                    return 0;
                }
            }
        }
    }

    return 0;
}
