#include <iostream>
#include <vector>
#include <queue>
#include <ctime>
#define endl '\n'
using namespace std;

const int MAXN = 5000;

bool used[MAXN + 5];
int path[MAXN + 5][4];
vector<int> G[MAXN + 5];

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    time_t st = clock();

    int n;
    cin >> n;

    for (int i = 1; i < n; ++ i)
    {
        string s;
        cin >> s;
        for (int j = i + 1, t = 0; j <= n; ++ j, ++ t)
        {
            if (s[t] == '1')
            {
                G[i].push_back(j);
                G[j].push_back(i);
            }
        }
    }

    bool flag = false;
    int ans = 4;
    for (int u = 1; u <= n; ++ u)
    {
        for (int v = 1; v <= n; ++ v)
        {
            used[v] = false;
            path[v][0] = path[v][1] = path[v][2] = path[v][3] = 0;
        }

        int cnt = 0, cntst = 0;
        queue< pair<int, int> > q;
        q.push({u, 0});
        path[u][0] = 1;
        while (q.size())
        {
            int u1 = q.front().first;
            int len1 = q.front().second;
            q.pop();
            if (!used[u1])
            {
                used[u1] = true;
                cnt++;
                if (G[u1].size() > 1) cntst++;
            }
            for (auto v1 : G[u1])
            {
                if (path[v1][len1 + 1] == 0 and len1 < 3) q.push({v1, len1 + 1});
                path[v1][len1 + 1]++;
            }
        }

        if (cnt <= 3 or cntst <= 1) continue;

        flag = true;

        for (int v = u + 1; v <= n; ++ v)
        {
            if (v != u and path[v][2] > 1)
            {
                cout << 2 << endl;
                return 0;
            }
        }

        for (int v = u + 1; v <= n; ++ v)
        {
            int cnt = path[v][3];
            if (path[v][1]) cnt -= G[u].size() + G[v].size() - 1;
            if (v != u and path[v][2] and cnt)
            {
                ans = 3;
                break;
            }
        }

        if (clock() - st > 0.245 * CLOCKS_PER_SEC) break;
    }

    if (!flag) cout << -1 << endl;
    else cout << ans << endl;

    return 0;
}
