#include <bits/stdc++.h>
#define endl "\n"
#define path_small 0
#define path_big 1
#define loop3 2
#define loop4 3
using namespace std;

const int maxn = 5e+3+5;

int n, answer = 42;
// bool mat[maxn][maxn];
vector<int> graph[maxn];
int sizes[maxn], parent[maxn];

bool visited[maxn];

void input();
void solve();

int main()
{
    input();
    solve();
    return 0;
}

void input()
{
    char c;
    cin >> n;
    for(int i = 1; i < n; i++)
    {
        for(int j = i+1; j <= n; j++)
        {
            cin >> c;
            bool isEdge = (c == '1');
            if(isEdge)
            {
                // mat[i][j] = mat[j][i] = 1;
                graph[i].emplace_back(j);
                graph[j].emplace_back(i);
                ++sizes[i], ++sizes[j];
            }
        }
    }
}

int explore(const int& start)
{
    queue<int> bfs;

    set<int> other_parents;

    parent[start] = 0;
    bfs.push(start);

    int current, iter, other, total_nodes = 0, total_sizes = 0, max_size = 0;

    bool has_loop3 = false;

    while(!bfs.empty())
    {
        current = bfs.front(); bfs.pop();

        // cout << "current: " << current << endl;

        ++total_nodes;
        total_sizes += sizes[current];
        max_size = max(sizes[current], max_size);

        visited[current] = true;

        other_parents.clear();
        for(iter = 0; iter < sizes[current]; iter++)
        {
            other = graph[current][iter];

            if(other == parent[current]) continue;

            if(visited[other])
            {
                if(parent[other] == 0) continue;

                if(other_parents.find(parent[other]) != other_parents.end())
                {
                    // cout << "hmmm: the prequel" << endl;
                    /*
                    cout << other << " " << parent[other] << endl;
                    for(auto k : other_parents)
                    {
                        cout << k << " ";
                    }
                    cout << endl;
                    */
                    return loop4;
                }

                if(parent[parent[other]] == parent[current])
                {
                    // cout << "hmmm" << endl;
                    return loop4;
                }

                if(parent[other] == parent[current]) has_loop3 = true;

                // cout << other << " " << parent[other] << endl;
                other_parents.insert(parent[other]);
            }
            else
            {
                visited[other] = true;
                parent[other] = current;
                bfs.push(other);
            }
        }
    }

    if(total_nodes < 4) return path_small;

    if(max_size == (total_sizes>>1)) return path_small;

    if(has_loop3) return loop3;

    return path_big;
}

void solve()
{
    int result = 0;
    for(int i = 1; i <= n; i++)
    {
        if(visited[i]) continue;
        result = explore(i);

        if(result == path_small) continue;
        if(result == loop4)
        {
            cout << 2 << endl;
            return;
        }
        if(result == loop3) answer = 3;
        else answer = min(answer, 5);
    }
    if(answer == 42)
    {
        cout << -1 << endl;
        return;
    }
    cout << answer << endl;
}

/*
4
110
11
0

5
1100
011
11
0

7
110000
01000
0100
011
11
0

7
101111
10000
0001
000
00
0

     .
  \ / \ /
 - / o \ -
  /_____\
  \#####/

*/
