#include <bits/stdc++.h>
#define endl "\n"
using namespace std;

const int maxn = 5e+3+5;

int n, answer = 42;
bool mat[maxn][maxn];
vector<int> graph[maxn];
int sizes[maxn], parent[maxn];
// stack<int> depths[maxn];
int depths[maxn];

bool visited[maxn];
bool traversed[maxn];

void input();
void solve();

int main()
{
    input();
    solve();
    return 0;
}

void input()
{
    char c;
    cin >> n;
    for(int i = 1; i < n; i++)
    {
        for(int j = i+1; j <= n; j++)
        {
            cin >> c;
            bool isEdge = (c == '1');
            if(isEdge)
            {
                mat[i][j] = mat[j][i] = 1;
                graph[i].emplace_back(j);
                graph[j].emplace_back(i);
                ++sizes[i], ++sizes[j];
            }
        }
    }
}


bool has_loop3 = false, has_loop4 = false, has_loop5 = false;
int total_nodes = 0, total_sizes = 0, max_size = 0;
void explore(const int& current, int depth)
{
    if(visited[current])
    {
        int loop_length = depth - depths[current];
        // cout << current << " " << loop_length << endl;
        has_loop3 = (has_loop3 || (loop_length == 3));
        has_loop4 = (has_loop4 || (loop_length == 4));
        has_loop5 = (has_loop5 || (loop_length == 5));
        return;
    }

    if(!traversed[current])
    {
        total_nodes++;
        total_sizes += sizes[current];
        max_size = max(max_size, sizes[current]);
    }
    traversed[current] = true;

    int previous_depth = depths[current];
    depths[current] = depth;
    visited[current] = true;
    for(int iter = 0; iter < sizes[current]; iter++)
    {
        explore(graph[current][iter], depth+1);
    }
    visited[current] = false;
    depths[current] = previous_depth;
}

void solve()
{
    for(int i = 1; i <= n; i++)
    {
        if(traversed[i]) continue;

        has_loop3 = has_loop4 = has_loop5 = false;
        total_nodes = total_sizes = max_size = 0;
        explore(i, 0);

        if(total_nodes < 4) continue;
        if(max_size == (total_sizes>>1)) continue;

        if(has_loop4) { cout << 2 << endl; return; }
        if(has_loop3 || has_loop5) answer = 3;
        else answer = min(answer, 4);
    }
    if(answer == 42) cout << -1 << endl;
    else cout << answer << endl;
}

/*
     .
  \ / \ /
 - / o \ -
  /_____\
  \#####/

*/
