#include <bits/stdc++.h>
#define endl "\n"
#define path_small 0
#define path_big 1
#define loop3 2
#define loop4 3
#define loop5 4
using namespace std;

const int maxn = 5e+3+5;

int n, answer = 42;
bool mat[maxn][maxn];
vector<int> graph[maxn];
int sizes[maxn], parent[maxn];

bool visited[maxn];
bool locked[maxn];
bool locked_extra[maxn];

void input();
void solve();

int main()
{
    input();
    solve();
    return 0;
}

void input()
{
    char c;
    cin >> n;
    for(int i = 1; i < n; i++)
    {
        for(int j = i+1; j <= n; j++)
        {
            cin >> c;
            bool isEdge = (c == '1');
            if(isEdge)
            {
                mat[i][j] = mat[j][i] = 1;
                graph[i].emplace_back(j);
                graph[j].emplace_back(i);
                ++sizes[i], ++sizes[j];
            }
        }
    }
}

int explore(const int& start, bool add_extra = false)
{
    queue<int> bfs;

    set<int> other_parents;

    parent[start] = 0;
    bfs.push(start);

    int current, iter, other, total_nodes = 0, total_sizes = 0, max_size = 0;

    bool has_loop3 = false, has_loop5 = false;

    while(!bfs.empty())
    {
        current = bfs.front(); bfs.pop();

        // cout << "current: " << current << endl;

        ++total_nodes;
        total_sizes += sizes[current];
        max_size = max(sizes[current], max_size);

        visited[current] = true;

        other_parents.clear();
        for(iter = 0; iter < sizes[current]; iter++)
        {
            other = graph[current][iter];

            if(!visited[other])
            {
                visited[other] = true;
                parent[other] = current;
                bfs.push(other);
                continue;
            }

            if(other == parent[current]) continue;

            if(parent[other] == 0) continue;

            int pother = parent[other];
            // cout << "extra: " << mat[current][other] << " " << locked_extra[current] << " " << locked_extra[other] << endl;
            if(add_extra && mat[current][pother] == 0 && !locked_extra[current] && !locked_extra[pother])
            {
                locked_extra[current] = true;
                locked_extra[pother] = true;
                locked_extra[parent[current]] = true;
                locked_extra[other] = true;
                mat[current][pother] = 2;
                mat[pother][current] = 2;
                ++sizes[current], ++sizes[pother];
                graph[current].emplace_back(pother);
                graph[pother].emplace_back(current);
                // cout << "added" << endl;
            }

            if(parent[other] == parent[current]) has_loop3 = true;
            if(mat[current][parent[other]]) has_loop3 = true;

            if(parent[parent[current]] != 0 && parent[parent[current]] == parent[parent[other]]) has_loop5 = true;
            // more loop 5 detection

            if(other_parents.find(parent[other]) != other_parents.end()) return loop4;
            if(parent[parent[other]] == parent[current]) return loop4;

            other_parents.insert(parent[other]);
        }
    }

    if(total_nodes < 4) return path_small;

    if(max_size == (total_sizes>>1)) return path_small;

    if(has_loop3) return loop3;
    if(has_loop5) return loop5;

    return path_big;
}

void lock_visited()
{
    for(int i = 1; i <= n; i++)
        locked[i] = locked[i] || visited[i];
}

void solve()
{
    int result = 0;
    for(int i = 1; i <= n; i++)
    {
        if(locked[i]) continue;

        memset(visited, 0, sizeof(visited));
        result = explore(i);

        if(result == path_small) continue;
        if(result == loop4)
        {
            cout << 2 << endl;
            return;
        }
        if(result == loop3 || result == loop5) { lock_visited(); answer = 3; }
        else
        {
            if(answer == 3) continue;
            // cout << "hmmmmmmmmmm" << endl;

            memset(visited, 0, sizeof(visited));
            result = explore(i, true);

            memset(visited, 0, sizeof(visited));
            result = explore(i);

            if(result == loop4) answer = 3;
            else answer = 4;

            lock_visited();
        }
    }
    if(answer == 42)
    {
        cout << -1 << endl;
        return;
    }
    cout << answer << endl;
}
