#include <bits/stdc++.h>
#include "crption.h"

using namespace std;

const int MAX_N = 5e5 + 10;
vector<pair<int, int> > g[MAX_N];
bool asked[MAX_N];
int flipped[MAX_N];
pair<int, int> ab[MAX_N];

const int MAX_K = 20;

multiset<pair<int, int> > inc;

vector<int> ans;
vector<pair<int, int> > real[MAX_N];

vector<int> cross;
int col[MAX_N];

bool ask(int ind) {
    if(asked[ind]) { return flipped[ind] == -1; }
    asked[ind] = true;
    flipped[ind] = check(ab[ind].first, ab[ind].second) ? -1 : 1;
    return flipped[ind] == -1;
}

vector<pair<int, int> > edges;

bool dfs(int x) {
    col[x] = 1;
    bool used = false;
    for(const auto &it : g[x]) {
        int ind = abs(it.second);
        if(it.second * flipped[ind] < 0) { continue; }
        if(col[it.first] == 1 && !asked[ind]) {
            if(!ask(it.second)) {
                while(edges.back().first != it.first) {
                    ask(edges.back().second);
                    edges.pop_back();
                }
                ask(edges.back().second);
                return true;
            }
        } else if(col[it.first] == 2) {
            if(!used && !asked[ind]) {
                used = true;
                cross.push_back(ind);
            }
            continue;
        }

        edges.push_back({x, ind});
        if(dfs(it.first)) {
            return true;
        }
        edges.pop_back();
    }
    col[x] = 2;
    return false;
}

bool used[MAX_N];
int n;
vector<int> sorted;

void topo(int x) {
    used[x] = true;
    for(const auto &it : g[x]) {
        if(it.second * flipped[abs(it.second)] < 0) { continue; }
        if(!used[it.first]) {
            topo(it.first);
        }
    }
    sorted.push_back(x);
}

void toposort() {
    sorted.resize(0);
    fill_n(used, MAX_N, false);
    for(int i = 0; i < n; i ++) {
        if(!used[i]) {
            topo(i);
        }
    }
    reverse(sorted.begin(), sorted.end());
}

vector<int> solve(const int &N, const vector<int> &from, const vector<int> &to) {
    n = N;
    for(int i = 0; i < from.size(); i ++) {
        g[from[i]].push_back({to[i], i + 1});
        g[to[i]].push_back({from[i], -i - 1});
        ab[i + 1] = {from[i], to[i]};
        flipped[i + 1] = 1;
    }

    for(int i = 0; i < n; i ++) {
        int ind = abs(g[i][0].second);
        ask(ind);
    }

    while(true) {
        fill_n(col, MAX_N, 0);
        edges.resize(0);
        if(!dfs(0)) {
            break;
        }
    }

    toposort();
    return sorted;
}

