#include <bits/stdc++.h>
#include "crption.h"

using namespace std;

const int MAX_N = 5e5 + 10;
vector<pair<int, int> > g[MAX_N];
bool asked[MAX_N];
int flipped[MAX_N];
pair<int, int> ab[MAX_N];

const int MAX_K = 20;

multiset<pair<int, int> > inc;

vector<int> ans;
vector<pair<int, int> > real[MAX_N];

vector<int> cross;
int col[MAX_N];

bool ask(int ind) {
    if(asked[ind]) { return flipped[ind] == -1; }
    asked[ind] = true;
    flipped[ind] = check(ab[ind].first, ab[ind].second) ? -1 : 1;
    return flipped[ind] == -1;
}

vector<pair<int, int> > edges;

bool dfs(int x) {
    col[x] = 1;
    bool used = false;
    for(const auto &it : g[x]) {
        int ind = abs(it.second);
        if(it.second * flipped[ind] < 0) { continue; }
        if(col[it.first] == 1 && !asked[ind]) {
            if(!ask(ind)) {
                while(edges.back().first != it.first) {
                    ask(edges.back().second);
                    edges.pop_back();
                }
                ask(edges.back().second);
                return true;
            }
        } else if(col[it.first] == 2) {
            if(!used && !asked[ind]) {
                used = true;
                cross.push_back(ind);
            }
            continue;
        }

        edges.push_back({x, ind});
        if(dfs(it.first)) { return true; }
        edges.pop_back();
    }
    col[x] = 2;
    return false;
}

bool used[MAX_N];
int n;
vector<int> sorted;

void topo(int x) {
    used[x] = true;
    for(const auto &it : g[x]) {
        if(it.second * flipped[abs(it.second)] < 0) { continue; }
        if(!used[it.first]) {
            topo(it.first);
        }
    }
    sorted.push_back(x);
}

int dp[MAX_N];

int toposort() {
    sorted.resize(0);
    fill_n(used, MAX_N, false);
    fill_n(dp, MAX_N, 0);
    for(int i = 0; i < n; i ++) {
        if(!used[i]) {
            topo(i);
        }
    }

    int ans = 0;
    reverse(sorted.begin(), sorted.end());
    for(int i = 0; i < n; i ++) {
        dp[i] = 1;
        for(const auto &it : g[i]) {
            if(it.second * flipped[abs(it.second)] > 0) { continue; }
            dp[i] = max(dp[i], dp[it.first] + 1);
        }
        ans = max(ans, dp[i]);
    }
    return ans;
}

int par[MAX_N], sz[MAX_N];

int find(int x) {
    if(x == par[x]) {
        return x;
    } else {
        return par[x] = find(par[x]);
    }
}

bool merge(int a, int b) {
    a = find(a);
    b = find(b);
    if(a == b) { return false; }
    if(sz[a] < sz[b]) { swap(a, b); }
    par[b] = a;
    sz[a] += sz[b];
    return true;
}

vector<int> solve(const int &N, const vector<int> &from, const vector<int> &to) {
    n = N;
    for(int i = 0; i < n; i ++) {
        sz[i] = 1;
        par[i] = i;
    }

    for(int i = 0; i < from.size(); i ++) {
        g[from[i]].push_back({to[i], i + 1});
        g[to[i]].push_back({from[i], -i - 1});
        ab[i + 1] = {from[i], to[i]};
        flipped[i + 1] = 1;

        if(merge(from[i], to[i])) {
            ask(i);
        }
    }

    while(toposort() < n) {
        fill_n(col, MAX_N, 0);
        edges.resize(0);

        bool flag = false;
        for(int i = 0; i < n; i ++) {
            if(col[i] == 0) {
                if(dfs(i)) {
                    flag = true;
                }
            }
        }
    }

    toposort();
    return sorted;
}

