#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll Size=5e3+1;
ll n,colors=0,ans=1e18;
ll color[Size];
ll dist[Size][Size];
vector<ll> adj[Size];
bool visited[Size];
pair<ll,ll> closest[Size];

void reset_visited(){
    for(ll i=0;i<n;i++){
        visited[i]=0;
    }
}

void coloring(ll curr_node){
    visited[curr_node]=1;
    color[curr_node]=colors;
    for(auto next_node:adj[curr_node]){
        if(!visited[next_node]){
            coloring(next_node);
        }
    }
}

void calc_dist(ll start_node,ll curr_node,ll depth){
    visited[curr_node]=1;
    dist[start_node][curr_node]=min(dist[start_node][curr_node],depth);
    dist[curr_node][start_node]=min(dist[curr_node][start_node],depth);
    for(auto next_node:adj[curr_node]){
        if(!visited[next_node]){
            calc_dist(start_node,next_node,depth+1);
        }
    }
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    for(ll i=0;i<n-1;i++){
        string a;
        cin>>a;
        for(ll j=i+1;j<n;j++){
            dist[i][j]=a[j-i-1]-'0';
            if(dist[i][j]==0){
                dist[i][j]=1e18;
            }else{
                adj[i].push_back(j);
                adj[j].push_back(i);
            }
            dist[j][i]=dist[i][j];
        }
    }
    if(n<4){
        cout<<-1<<endl;
        return 0;
    }
    for(ll i=0;i<n;i++){
        if(!visited[i]){
            coloring(i);
            colors++;
        }
    }
    for(ll i=0;i<n;i++){
        reset_visited();
        calc_dist(i,i,0);
    }
    /*
    for(ll i=0;i<n;i++){
        for(ll j=0;j<n;j++){
            cout<<dist[i][j]<<" ";
        }
        cout<<endl;
    }
    */
    for(ll i=0;i<n;i++){
        ll c=0;
        for(ll j=0;j<n;j++){
            if(dist[i][j]==1)
                c++;
        }
        closest[i].first=1e18;
        closest[i].second=1e18;
        for(ll j=0;j<n;j++){
            if((dist[i][j]==1 and c==1) or color[i]!=color[j] or dist[i][j]==0)
                continue;
            closest[i]=min(closest[i],{dist[i][j],j});
            closest[j]=min(closest[j],{dist[i][j],i});
        }
    }
    for(ll i=0;i<n;i++)
        assert(closest[i].second!=1e18);
    cout<<-10000<<endl;
    return 0;
    for(ll i=0;i<n;i++){
        for(auto next_node1:adj[i]){
            for(auto next_node2:adj[closest[i].second]){
                if(next_node1!=next_node2 and next_node1!=closest[i].second and next_node2!=i){
                    ll d1=dist[i][closest[i].second]+dist[next_node1][next_node2];
                    ll d2=dist[i][next_node2]+dist[closest[i].second][next_node1];
                    ans=min(ans,min(d1,d2));
                }
            }
        }
    }
    if(ans==1e18){
        cout<<-1<<endl;
    }else{
        cout<<ans<<endl;
    }
    return 0;
}
/*
4
111
11
1

4
110
11
1

7
110000
11100
0011
000
00
0
*/
