#include <iostream>
#include <string>
#include <algorithm>
#include <queue>

#define endl '\n'

using namespace std;

bool check(int max_jumps, int m, string &maze)
{
    if (maze[max_jumps] == '#')
    {
        return false;
    }

    queue<pair<int, int>> bfs;
    bfs.push({max_jumps, max_jumps - 1});

    while (!bfs.empty())
    {
        int pos = bfs.front().first;
        int limit = bfs.front().second;
        bfs.pop();

        if (pos == m - 1)
        {
            return true;
        }

        for (int jumps = min(m - 1 - pos, limit); jumps > 0; --jumps)
        {
            if (maze[pos + jumps] == '.')
            {
                bfs.push({pos + jumps, jumps - 1});
            }
        }
    }

    return false;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    string maze;
    cin >> maze;

    reverse(maze.begin(), maze.end());

    int l = 1, r = m - 1;
    while (l <= r)
    {
        int mid = (l + r) / 2;

        if (check(mid, m, maze))
        {
            r = mid - 1;
        }
        else
        {
            l = mid + 1;
        }
    }

    cout << -1 << endl;

    return 0;
}
