#include <iostream>
#include <vector>
#include <queue>

#define endl '\n'

using namespace std;

const int MAXN = 5e3 + 3;

vector<int> graph[MAXN];
int dist[MAXN];

void calculate_distance(int startv, int n)
{
    for (int i = 0; i < n; ++i)
    {
        dist[i] = -1;
    }
    dist[startv] = 0;

    queue<int> bfs;
    bfs.push(startv);

    while (!bfs.empty())
    {
        int currv = bfs.front();
        bfs.pop();

        for (int nextv : graph[currv])
        {
            if (dist[nextv] == -1)
            {
                dist[nextv] = dist[currv] + 1;
                bfs.push(nextv);
            }
        }
    }
}

int find_min(int startv, int n)
{
    calculate_distance(startv, n);

    int result = n * n;
    for (int neighbor1 : graph[startv])
    {
        for (int neighbor2 : graph[neighbor1])
        {
            if (neighbor2 == startv)
            {
                continue;
            }

            for (int neighbor3 : graph[neighbor2])
            {
                if (neighbor3 != neighbor1 and neighbor3 != startv and dist[neighbor3] != -1)
                {
                    result = min(result, 1 + dist[neighbor3]);
                }
            }
        }
    }

    return result;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    for (int currv = 0; currv < n - 1; ++currv)
    {
        string input;
        cin >> input;

        for (int nextv = currv + 1; nextv < n; ++nextv)
        {
            if (input[nextv - currv - 1] == '1')
            {
                graph[currv].push_back(nextv);
                graph[nextv].push_back(currv);
            }
        }
    }

    int result = n * n;
    for (int i = 0; i < n; ++i)
    {
        result = min(result, find_min(i, n));
    }

    cout << result << endl;

    return 0;
}
