#include <iostream>
#include <vector>
#include <queue>

#define endl '\n'

using namespace std;

const int MAXN = 5e3 + 3;
const int INF = 1e9;

vector<int> graph[MAXN];
int dist[MAXN][MAXN];

void calculate_distance(int startv, int n)
{
    for (int i = 0; i < n; ++i)
    {
        dist[startv][i] = -1;
    }
    dist[startv][startv] = 0;

    queue<int> bfs;
    bfs.push(startv);

    while (!bfs.empty())
    {
        int currv = bfs.front();
        bfs.pop();

        for (int nextv : graph[currv])
        {
            if (dist[startv][nextv] == -1)
            {
                dist[startv][nextv] = dist[startv][currv] + 1;
                bfs.push(nextv);
            }
        }
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    for (int currv = 0; currv < n - 1; ++currv)
    {
        string input;
        cin >> input;

        for (int nextv = currv + 1; nextv < n; ++nextv)
        {
            if (input[nextv - currv - 1] == '1')
            {
                graph[currv].push_back(nextv);
                graph[nextv].push_back(currv);
            }
        }
    }

    for (int i = 0; i < n; ++i)
    {
        calculate_distance(i, n);
    }

    int result = INF;
    for (int u1 = 0; u1 < n; ++u1)
    {
        for (int v1 : graph[u1])
        {
            for (int u2 = 0; u2 < n; ++u2)
            {
                if (u2 == u1 or u2 == v1)
                {
                    continue;
                }

                for (int v2 : graph[u2])
                {
                    if (v2 == u1 or v2 == v1)
                    {
                        continue;
                    }

                    if (dist[u1][u2] != -1 and dist[v1][v2] != -1)
                    {
                        result = min(result, dist[u1][u2] + dist[v1][v2]);
                    }
                    if (dist[u1][v2] != -1 and dist[v1][u2] != -1)
                    {
                        result = min(result, dist[u1][v2] + dist[v1][u2]);
                    }
                }
            }
        }
    }

    cout << (result == INF ? -1 : result) << endl;

    return 0;
}
