#include <iostream>
#include <vector>

#include "crption.h"

using namespace std;

void dfs(int currv, vector<int> &topo, vector<vector<int>> &graph, vector<bool> &used)
{
    used[currv] = true;

    for (int nextv : graph[currv])
    {
        if (!used[nextv])
        {
            dfs(nextv, topo, graph, used);
        }
    }

    topo.push_back(currv);
}

vector<int> solve(const int &n, const vector<int> &_from, const vector<int> &_to)
{
    vector<int> from = _from;
    vector<int> to = _to;

    int m = (int) from.size();

    vector<vector<int>> graph(n);
    vector<int> in_degree(n);

    for (int i = 0; i < m; ++i)
    {
        if (i % 2 == 1)
        {
            if (check(from[i], to[i]))
            {
                swap(from[i], to[i]);
            }
        }

        graph[to[i]].push_back(from[i]);
        ++in_degree[from[i]];
    }

    int startv = -1;
    for (int i = 0; i < n; ++i)
    {
        if (in_degree[i] == 0)
        {
            startv = i;
            break;
        }
    }

    vector<int> result;
    vector<bool> used(n);
    dfs(startv, result, graph, used);

    return result;
}

