#include<iostream>
#include<vector>
#include<queue>
using namespace std;

int broiVarhove;

vector<int> sasedstvo[5010];

int broiKomp;
int komponentaNom[5010];
vector<int> vTaziKomp[5010];

struct DanniZaSaseda{
    int koiE;
    int razst;

    DanniZaSaseda(int koiE, int razst)
        :koiE(koiE), razst(razst)
    {

    }
};

struct KoiEPoNapred{
    bool operator()(DanniZaSaseda const& a, DanniZaSaseda const& b)
    {
        return a.razst > b.razst;
    }
};

int naiKasoRazstOtDo[5010][5010];
bool imameLiNaiKasoOtDo[5010][5010];

void bfs(int start){

    for(int i = 0; i < broiVarhove; i++){
        naiKasoRazstOtDo[start][i] = 5050;
    }

    priority_queue<DanniZaSaseda, vector<DanniZaSaseda>, KoiEPoNapred> q;
    q.push({start, 0});

    while(q.empty() == false){
        DanniZaSaseda naiOtgore = q.top();
        q.pop();

        if(imameLiNaiKasoOtDo[start][naiOtgore.koiE]){
            continue;
        }

        naiKasoRazstOtDo[start][naiOtgore.koiE] = naiOtgore.razst;
        imameLiNaiKasoOtDo[start][naiOtgore.koiE] = true;

        for(int i = 0; i < (int)sasedstvo[naiOtgore.koiE].size(); i++){
            if(imameLiNaiKasoOtDo[start][sasedstvo[naiOtgore.koiE][i]] == false){
                q.push({sasedstvo[naiOtgore.koiE][i], naiOtgore.razst + 1});
            }
        }
    }

}

void dfsOcvet(int segashenVrah, int cvqt){
    komponentaNom[segashenVrah] = cvqt;
    vTaziKomp[cvqt].push_back(segashenVrah);

    for(int i = 0; i < (int)sasedstvo[segashenVrah].size(); i++){
        if(komponentaNom[sasedstvo[segashenVrah][i]] == 0){
            dfsOcvet(sasedstvo[segashenVrah][i], cvqt);
        }
    }
}

int main(){

    cin>>broiVarhove;

    for(int i = 0; i < broiVarhove - 1; i++){
        string toqRed;
        cin>>toqRed;
        for(int j = i + 1; j < broiVarhove; j++){
            if(toqRed[j - i - 1] == '1'){
                sasedstvo[i].push_back(j);
                sasedstvo[j].push_back(i);
            }
        }
    }

    if(broiVarhove < 4){
        cout<<-1<<endl;
        return 0;
    }

    /*
    for(int i = 0; i < broiVarhove; i++){
        cout<<i<<":"<<endl;
        for(auto j : sasedstvo[i]){
            cout<<j<<" ";
        }
        cout<<endl;
    }
    */

    for(int i = 0; i < broiVarhove; i++){
        bfs(i);
        naiKasoRazstOtDo[i][i] = 5050;
    }

    /*
    for(int i = 0; i < broiVarhove; i++){
        for(int j = 0; j < broiVarhove; j++){
            cout<<i<<" "<<j<<" "<<naiKasoRazstOtDo[i][j]<<endl;
        }
        cout<<endl;
    }
    */


    /*
    for(int i = 0; i < broiVarhove; i++){
        if(komponentaNom[i] == 0){
            broiKomp++;
            dfsOcvet(0, broiKomp);
        }
    }
    */


    int naiMalakSbor = 5050;

    for(int i = 0; i < broiVarhove; i++){
        for(int j = 0; j < broiVarhove; j++){
            if(j == i){
                continue;
            }

            for(int s1 = 0; s1 < sasedstvo[i].size(); s1++){
                for(int s2 = 0; s2 < sasedstvo[j].size(); s2++){
                    if(sasedstvo[i][s1] == sasedstvo[j][s2] || sasedstvo[i][s1] == j || sasedstvo[j][s2] == i){
                        continue;
                    }
                    int tukaRazst = naiKasoRazstOtDo[sasedstvo[i][s1]][sasedstvo[j][s2]] + naiKasoRazstOtDo[i][j];

                    naiMalakSbor = min(naiMalakSbor, tukaRazst);
                }
            }
        }
    }

    if(naiMalakSbor < 5050){
        cout<<naiMalakSbor<<endl;
    }else{
        cout<<-1<<endl;
    }


    return 0;
}
