#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <bitset>

typedef long long llong;
const int MAXN = 1e6 + 10;
const int INF  = 1e9;

struct Key
{
    int x, y, t;
    inline friend bool operator < (const Key &a, const Key &b)
    {
        return 1LL * MAXN * MAXN * a.t + MAXN * a.x + a.y < 1LL * MAXN * MAXN * b.t + MAXN * b.x + b.y;
    }
};


int n, m;
inline llong getKey(const Key &a)
{
    return 1LL * n * m * a.t + m * a.x + a.y;
}

std::string t[MAXN];
std::unordered_map <llong,int> mem;

int f(Key k)
{
    if (k.t > std::max(n, m) || k.x < 0 || k.y < 0 || k.x >= n || k.y >= m || t[k.x][k.y] == '#')
    {
        return INF;
    }

    if (k.x == n - 1 && k.y == m - 1)
    {
        return k.t - 1;
    }

    if (mem.count(getKey(k)))
    {
        return mem[getKey(k)];
    }

    int res = f({k.x, k.y, k.t + 1});
    res = std::min(res, f({k.x - k.t, k.y, k.t + 1}));
    res = std::min(res, f({k.x + k.t, k.y, k.t + 1}));
    res = std::min(res, f({k.x, k.y - k.t, k.t + 1}));
    res = std::min(res, f({k.x, k.y + k.t, k.t + 1}));
    return res;
}

void solve()
{
    if (t[n][m] == '#')
    {
        std::cout << -1 << '\n';
        return;
    }
    std::cout << f({0, 0, 1}) << '\n';
}

void input()
{
    std::cin >> n >> m;
    for (int i = 0 ; i < n ; ++i)
    {
        std::cin >> t[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    srand(229295);
    fastIO();
    input();
    solve();

    return 0;
}
