#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <bitset>

typedef long long llong;
const int MAXN = 5000 + 10;
const int INF  = 1e9;

int n, m;
std::string t[MAXN];
int dp[MAXN][MAXN];
bool bl[MAXN][MAXN];

int f(int x, int y, int time)
{
    if (time > std::max(n, m) || x < 0 || y < 0 || x >= n || y >= m || t[x][y] == '#')
    {
        return INF;
    }

    if (x == n - 1 && y == m - 1)
    {
        return time - 1;
    }

    if (bl[m * x + y][time])
    {
        return dp[m * x + y][time];
    }

    bl[m * x + y][time] = true;
    int res = f(x, y, time + 1);
    res = std::min(res, f(x - time, y, time + 1));
    res = std::min(res, f(x + time, y, time + 1));
    res = std::min(res, f(x, y - time, time + 1));
    res = std::min(res, f(x, y + time, time + 1));
    return dp[m * x + y][time] = res;
}

void solve()
{
    if (t[n - 1][m - 1] == '#')
    {
        std::cout << -1 << '\n';
        return;
    }

    if (f(0, 0, 1) == INF) std::cout << -1 << '\n';
    else std::cout << f(0, 0, 1) << '\n';
}

void input()
{
    std::cin >> n >> m;
    for (int i = 0 ; i < n ; ++i)
    {
        std::cin >> t[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    srand(229295);
    fastIO();
    input();
    solve();

    return 0;
}
