#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <bitset>

typedef long long llong;
const int MAXN = 5000 + 10;
const int INF  = 1e9;

int n, m;
std::string t[MAXN];
int dp[MAXN][MAXN];
void solve()
{
    if (t[n - 1][m - 1] == '#')
    {
        std::cout << "-1\n";
        return;
    }

    for (int i = 0 ; i < n ; ++i)
    {
        for (int j = 0 ; j < m ; ++j)
        {
            dp[i * m + j][std::max(n, m)] = INF;
        }
    }

    dp[n * m - 1][std::max(n, m)] = std::max(n, m) - 1;
    for (int time = std::max(n, m) - 1 ; time >= 1 ; --time)
    {
        for (int i = 0 ; i < n ; ++i)
        {
            for (int j = 0 ; j < m ; ++j)
            {
                if (t[i][j] == '#')
                {
                    dp[i * m + j][time] = INF;
                    continue;
                }

                if (i == n - 1 && j == m - 1)
                {
                    dp[i * m + j][time] = time - 1;
                    break;
                }

                dp[i * m + j][time] = dp[i * m + j][time + 1];
                if (i >= time) dp[i * m + j][time] = std::min(dp[i * m + j][time], dp[(i - time) * m + j][time + 1]);
                if (i + time < n) dp[i * m + j][time] = std::min(dp[i * m + j][time], dp[(i + time) * m + j][time + 1]);
                if (j >= time) dp[i * m + j][time] = std::min(dp[i * m + j][time], dp[i * m + j - time][time + 1]);
                if (j + time < m) dp[i * m + j][time] = std::min(dp[i * m + j][time], dp[i * m + j + time][time + 1]);
            }
        }
    }

    if (dp[0][1] == INF) std::cout << -1 << '\n';
    else std::cout << dp[0][1] << '\n';
}

void input()
{
    std::cin >> n >> m;
    for (int i = 0 ; i < n ; ++i)
    {
        std::cin >> t[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}
