#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <bitset>
#include <queue>
#include <set>

typedef long long llong;
const int MAXSQ = 1000 + 10;
const int MAXN = 1000000 + 10;
const int INF  = 1e9;

int n, m;
int myTime[MAXN];
std::string s[MAXN];
std::queue <std::pair <int,int>> q[MAXSQ];
std::pair <int,int> delta[] = {{-1, 0}, {0, -1}, {1, 0}, {0, 1}};

inline int getCellNum(int x, int y)
{
    return m * x + y;
}

inline bool inside(int x, int y)
{
    return x >= 0 && x < n && y >= 0 && y < m;
}

int dp[MAXN];
int perm[MAXN];
std::set <std::pair <int,int>> vals;
void solve()
{
    if (s[0][0] == '#' || s[n - 1][m - 1] == '#')
    {
        std::cout << "-1\n";
        return;
    }

    q[0].push({0, 0});
    std::fill(myTime, myTime + n * m, INF);
    for (int t = 0 ; t <= std::min(n, m) ; ++t)
    {
        while (!q[t].empty())
        {
            auto [x, y] = q[t].front();
            q[t].pop();

            if (myTime[getCellNum(x, y)] != INF) continue;
            myTime[getCellNum(x, y)] = t;

            for (int nextT = t + 1 ; nextT <= std::min(n, m) ; ++nextT)
            {
                for (const auto &[dx, dy] : delta)
                {
                    if (inside(x + dx * nextT, y + dy * nextT) && s[x + dx * nextT][y + dy * nextT] != '#')
                    {
                        q[nextT].push({x + dx * nextT, y + dy * nextT});
                    }
                }
            }
        }
    }

    if (n <= m)
    {
        for (int i = 1 ; i <= m ; ++i)
        {
            dp[i] = myTime[getCellNum(n - 1, i - 1)];
            vals.insert({dp[i], i});
        }

        while (!vals.empty())
        {
            auto [val, idx] = *vals.begin();
            vals.erase(vals.begin());
            for (int i = 1 ; i <= m ; ++i)
            {
                if (s[n - 1][i - 1] == '#') continue;
                if (abs(i - idx) > val && dp[i] > abs(i - idx))
                {
                    vals.erase(vals.find({dp[i], i}));
                    dp[i] = abs(i - idx);
                    vals.insert({dp[i], i});
                }
            }
        }

        if (dp[m] == INF) std::cout << -1 << '\n';
        else std::cout << dp[m] << '\n';
    } else
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            dp[i] = myTime[getCellNum(i - 1, m - 1)];
            vals.insert({dp[i], i});
        }

        while (!vals.empty())
        {
            auto [val, idx] = *vals.begin();
            vals.erase(vals.begin());
            for (int i = 1 ; i <= n ; ++i)
            {
                if (s[i - 1][m - 1] == '#') continue;
                if (abs(i - idx) > val && dp[i] > abs(i - idx))
                {
                    vals.erase(vals.find({dp[i], i}));
                    dp[i] = abs(i - idx);
                    vals.insert({dp[i], i});
                }
            }
        }

        if (dp[n] == INF) std::cout << -1 << '\n';
        else std::cout << dp[n] << '\n';
    }
}

void input()
{
    std::cin >> n >> m;
    for (int i = 0 ; i < n ; ++i)
    {
        std::cin >> s[i];
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}

/**
2 20
.#.##.#..###..#.####
..#.#..######..#..#.
*/
