#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <bitset>

typedef long long llong;
const int MAXN = 5000 + 10;
const int INF  = 1e9;

int n;
int a[MAXN];
int dist[MAXN][MAXN];
void solve()
{
    for (int k = 1 ; k <= n ; ++k)
    {
        for (int i = 1 ; i <= n ; ++i)
        {
            for (int j = 1 ; j <= n ; ++j)
            {
                if (i == j || i == k || j == k)
                {
                    continue;
                }

                if (dist[i][j] > dist[i][k] + dist[k][j])
                {
                    dist[i][j] = dist[i][k] + dist[k][j];
                }
            }
        }
    }

    int ans = INF;
    for (int u1 = 1 ; u1 <= n ; ++u1)
    {
        for (int u2 = 1 ; u2 <= n ; ++u2)
        {
            if (u1 == u2) continue;
            for (int v1 = 1 ; v1 <= n ; ++v1)
            {
                if (u1 == v1 || u2 == v1) continue;
                for (int v2 = 1 ; v2 <= n ; ++v2)
                {
                    if (u1 == v2 || u2 == v2 || v1 == v2) continue;
                    if (dist[u1][v1] != 1 || dist[u2][v2] != 1) continue;
                    ans = std::min(ans, dist[u1][u2] + dist[v1][v2]);
                }
            }
        }
    }

    if (ans == INF) std::cout << -1 << '\n';
    else std::cout << ans << '\n';
}

char s[MAXN];
void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n - 1 ; ++i)
    {
        std::cin >> s + 1;
        for (int j = i + 1 ; j <= n ; ++j)
        {
            if (s[j - i] == '1')
            {
                dist[i][j] = 1;
                dist[j][i] = 1;
            } else
            {
                dist[i][j] = INF;
                dist[j][i] = INF;
            }
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}
