#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <bitset>

typedef long long llong;
const int MAXN = 5000 + 10;
const int INF  = 1e9;

int n;
int a[MAXN];
bool bs[MAXN][MAXN];
int common[MAXN][MAXN];
std::vector <int> v[MAXN];
std::vector <int> pairs[MAXN];
bool neigh[MAXN];
bool vis[MAXN];
void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        std::fill(vis + 1, vis + 1 + n, false);
        for (const int &j : v[i])
        {
            for (const int &k : v[j])
            {
                if (vis[k] && k != i)
                {
                    std::cout << 2 << '\n';
                    exit(0);
                }

                vis[k] = true;
                if (i != k)
                {
                    common[i][k] = j;
                    common[k][i] = j;
                    pairs[i].push_back(k);
                }
            }
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        if (v[i].size() < 3) continue;
        std::fill(neigh + 1, neigh + 1 + n, false);
        for (const int &j : v[i])
        {
            for (const int &k : v[j])
            {
                if (neigh[k])
                {
                    std::cout << 3 << '\n';
                    exit(0);
                }
            }

            neigh[j] = true;
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        for (const int &k : pairs[i])
        {
            if (bs[i][k]) continue;
            for (const int &j : v[k])
            {
                if (common[i][j] && common[i][j] != common[i][k])
                {
                    std::cout << 3 << '\n';
                    exit(0);
                }
            }
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        if (v[i].size() == 1) continue;
        for (const int &j : v[i])
        {
            if (v[i].size() >= 3 && v[j].size() >= 2)
            {
                std::cout << 4 << '\n';
                exit(0);
            }

            if (v[i].size() == 2 && v[j].size() == 2)
            {
                int curr = v[i][0];
                if (curr == j) curr = v[i][1];
                int curr2 = v[j][0];
                if (curr2 == i) curr2 = v[j][1];
                if (curr != curr2)
                {
                    std::cout << 4 << '\n';
                    exit(0);
                }
            }
        }
    }

    std::cout << -1 << '\n';
}

char s[MAXN];
void input()
{
    std::cin >> n;
    for (int i = 1 ; i <= n - 1 ; ++i)
    {
        std::cin >> s + 1;
        for (int j = i + 1 ; j <= n ; ++j)
        {
            bs[i][j] = s[j - i] - '0';
            bs[j][i] = s[j - i] - '0';
            if (s[j - i] == '1')
            {
                v[i].push_back(j);
                v[j].push_back(i);
            }
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIO();
    input();
    solve();

    return 0;
}
