#include <algorithm>
#include <iostream>
#include <numeric>
#include <vector>
#include <bitset>

#pragma GCC optimize ("O3,unroll_loops")
#pragma GCC target ("sse4")

typedef long long llong;
const int MAXN = 5000 + 10;
const int INF  = 1e9;

const int BUFF_SIZE = 1e5;
int buffPos = BUFF_SIZE - 1;
char buff[BUFF_SIZE];

inline void readChar()
{
    if (++buffPos == BUFF_SIZE) fread(buff, BUFF_SIZE, 1, stdin), buffPos = 0;
}

inline void readString(char s[])
{
    int pos = 0;
    for (; buff[buffPos] < '0' || buff[buffPos] > '1'; readChar());
    for (; buff[buffPos] >= '0' && buff[buffPos] <= '1'; readChar())
        s[pos++] = buff[buffPos];
}

inline void readInt(int &num)
{
    num = 0;
    for (; buff[buffPos] < '0' || buff[buffPos] > '9'; readChar());
    for (; buff[buffPos] >= '0' && buff[buffPos] <= '9'; readChar())
        num = 10 * num + buff[buffPos] - '0';
}

int n;
int g[MAXN];
int perm[MAXN];
int v[MAXN][MAXN];
bool bs[MAXN][MAXN];
int common[MAXN][MAXN];
std::bitset <MAXN> pairs[MAXN];
std::bitset <MAXN> neigh;
std::bitset <MAXN> vis;
void solve()
{
    for (int i = 1 ; i <= n ; ++i)
    {
        int j, k;
        vis.reset();
        for (int j1 = 0 ; j1 < g[i] ; ++j1)
        {
            j = v[i][j1];
            for (int k1 = 0 ; k1 < g[j] ; ++k1)
            {
                k = v[j][k1];
                if (i == k) continue;
                if (vis[k])
                {
                    std::cout << 2 << '\n';
                    return;
                }

                vis[k] = 1;
                common[i][k] = j;
                pairs[i][k] = 1;
            }
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        for (int k = 1 ; k <= n ; ++k)
        {
            if (pairs[i][k] && bs[i][k] && g[common[i][k]] > 2)
            {
                std::cout << 3 << '\n';
                return;
            }
        }
    }

    for (int i = 1 ; i <= n ; ++i)
    {
        int j;
        for (int k = i + 1 ; k <= n ; ++k)
        {
            if (!pairs[i][k] || bs[i][k]) continue;
            for (int j1 = 0 ; j1 < g[k] ; ++j1)
            {
                j = v[k][j1];
                if (common[i][j] && common[i][j] != common[i][k])
                {
                    std::cout << 3 << '\n';
                    return;
                }
            }
        }
    }

    int curr, curr2;
    for (int i = 1 ; i <= n ; ++i)
    {
        int j;
        if (g[i] == 1) continue;
        for (int j1 = 0 ; j1 < g[i] ; ++j1)
        {
            j = v[i][j1];
            if (g[i] > 2 && g[j] >= 1)
            {
                std::cout << 4 << '\n';
                return;
            }

            if (g[i] == 2 && g[j] == 2)
            {
                curr = v[i][1 ^ j1];
                if (curr2 == i) curr2 = v[j][1];
                if (curr != curr2)
                {
                    std::cout << 4 << '\n';
                    return;
                }
            }
        }
    }

    std::cout << -1 << '\n';
}

char s[MAXN];
void input()
{
    readInt(n);
    for (int i = 1 ; i < n ; ++i)
    {
        readString(s);
        for (int j = i + 1 ; j <= n ; ++j)
        {
            bs[i][j] = s[j - i - 1] - '0';
            bs[j][i] = s[j - i - 1] - '0';
            if (s[j - i - 1] == '1')
            {
                v[i][g[i]++] = j;
                v[j][g[j]++] = i;
            }
        }
    }
}

void fastIO()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    srand(229295);
    fastIO();
    input();
    solve();

    return 0;
}
