#include "crption.h"
#include <iostream>
#include <vector>
#include <stack>

const int MAXN = 100000 + 10;
const int INF  = 1e9;

bool vis[MAXN];
std::vector <int> perm;
std::vector <int> v[MAXN];
std::vector <int> g[MAXN];
std::stack <int> st;

void dfs(int node)
{
    vis[node] = true;
    for (const int &i : g[node])
    {
        if (vis[i]) continue;
        dfs(i);
    }

    st.push(node);
}
std::vector <int> solve(const int &n, const std::vector <int> &from, const std::vector <int> &to)
{
    perm.resize(n, 0);
    for (int i = 0 ; i < from.size() ; ++i)
    {
        v[from[i]].push_back(to[i]);
    }

    for (int i = 0 ; i < n ; ++i)
    {
        for (const int &j : v[i])
        {
            if (!check(i, j))
            {
                g[j].push_back(i);
            } else
            {
                g[i].push_back(j);
            }
        }
    }

    for (int i = 0 ; i < n ; ++i)
    {
        if (vis[i]) continue;
        dfs(i);
    }

    int cnt = n - 1;
    for (int i = 0 ; i < n ; ++i)
    {
        perm[st.top()] = cnt--;
        st.pop();
    }

    return perm;
}
