#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 6050;
const int INF = 1e9;

int n, m;
int cell[MAXN];

int dp[MAXN][MAXN];

inline bool OnBoard(int x, int y)
{
    if (x < 1 || y < 1 || x > n || y > m)
        return false;

    return true;
}

inline int HashCell(int x, int y)
{
    return ((x-1)*m + y);
}

int Solve(int x, int y, int t)
{
    if (t > m && t > n)
        return  INF;

    if (cell[HashCell(x, y)] == -1)
        return INF;

    if (!OnBoard(x, y))
        return INF;

    if (x == n && y == m)
        return 0;

    if (dp[HashCell(x, y)][t] != -1)
        return dp[HashCell(x, y)][t];

    int ans = INF;


    ans = min(ans, Solve(x, y, t+1)+1);
    ans = min(ans, Solve(x+t, y, t+1)+1);
    ans = min(ans, Solve(x-t, y, t+1)+1);
    ans = min(ans, Solve(x, y+t, t+1)+1);
    ans = min(ans, Solve(x, y-t, t+1)+1);

    dp[HashCell(x, y)][t] = ans;

    return ans;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    memset(dp, -1, sizeof(dp));

    cin >> n >> m;
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= m; j++)
        {
            char c;
            cin >> c;

            if (c == '.')
                cell[HashCell(i, j)] = 0;

            if (c == '#')
                cell[HashCell(i, j)] = -1;
        }
    }

    cout << Solve(1, 1, 1) << endl;
    return 0;
}
