#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 5050;
const int MAXM = MAXN*MAXN;

int dist[MAXN][MAXN], N;

vector <int> Graph[MAXN];

bool GraphMatrix[MAXN][MAXN];

void BFS(int source)
{
    queue <int> q;

    dist[source][source] = 0;
    q.push(source);

    while (!q.empty())
    {
        int currNode = q.front();
        q.pop();

        for (int i:Graph[currNode])
        {

            if (dist[source][i] == -1)
            {
                dist[source][i] = dist[source][currNode] + 1;
                dist[i][source] = dist[source][i];

                q.push(i);
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    memset(dist, -1, sizeof(dist));

    cin >> N;

    for (int i = 1; i < N; i++)
    {
        for (int j = i+1; j <= N; j++)
        {
            char hasEdge;
            cin >> hasEdge;

            if (hasEdge == '1')
            {
                Graph[i].push_back(j);
                Graph[j].push_back(i);

                GraphMatrix[i][j] = GraphMatrix[j][i] = true;
            }
        }
    }

    for (int i = 1; i <= N; i++)
        BFS(i);

    int u1, u2, v1, v2;
    int ans = 1e9;

    for (u1 = 1; u1 <= N; u1++)
    {
        for (v1 = u1+1; v1 <= N; v1++)
        {
            for (u2 = 1; u2 <= N; u2++)
            {
                for (v2 = u2+1; v2 <= N; v2++)
                {

                    if (v1 == v2 || v1 == u2 || u1 == u2 || u1 == v2)
                        continue;
                    if (dist[u1][v1] != 1 || dist[u2][v2] != 1)
                        continue;

                    if (dist[u1][u2] == -1 || dist[v1][v2] == -1)
                        continue;


                    ans = min(ans, dist[u1][u2] + dist[v1][v2]);
                }
            }
        }
    }
    cout << ans << endl;


    return 0;
}
/*
4
111
11
1
*/
