#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN = 5050;
const int INF = 1e9;

int dist[MAXN][MAXN], N;
int v1 = -1, u2 = -1, v2 = -1, ans = INF;
vector <int> Graph[MAXN];

void BFS(int source)
{
    queue <int> q;

    dist[source][source] = 0;
    q.push(source);

    while (!q.empty())
    {
        int currNode = q.front();
        q.pop();

        for (int i:Graph[currNode])
        {

            if (dist[source][i] == -1)
            {
                dist[source][i] = dist[source][currNode] + 1;
                dist[i][source] = dist[source][i];

                q.push(i);
            }
        }
    }
}

void DFS(int u1, int currNode, int disttravelled)
{
    if (disttravelled == 3)
    {
        if (v1 == -1 || u2 == -1 || v2 == -1)
            return;

        ans = min(ans, dist[u1][u2]+dist[v1][v2]);
    }

    for (int i:Graph[currNode])
    {
        if (i == u1 || i == u2 || i == v1 || i == v2)
            continue;

        if (disttravelled == 0)
        {
            v1 = i;
            DFS(u1, i, 1);
            v1 = -1;
        }

        if (disttravelled == 1)
        {
            v2 = i;
            DFS(u1, i, 2);
            v2 = -1;
        }

        if (disttravelled == 2)
        {
            u2 = i;
            DFS(u1, i, 3);
            u2 = -1;
        }
    }

}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    memset(dist, -1, sizeof(dist));

    cin >> N;

    for (int i = 1; i < N; i++)
    {
        for (int j = i+1; j <= N; j++)
        {
            char hasEdge;
            cin >> hasEdge;

            if (hasEdge == '1')
            {
                Graph[i].push_back(j);
                Graph[j].push_back(i);
            }
        }
    }

    for (int i = 1; i <= N; i++)
        BFS(i);

    for (int i = 1; i <= N; i++)
        DFS(i, i, 0);

    if (ans == INF)
        cout << -1 << endl;
    else
        cout << ans << endl;


    return 0;
}
/*
4
111
11
1
*/
